/*
 * Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.registry.web.actions;

import org.wso2.registry.Registry;
import org.wso2.registry.RegistryConstants;
import org.wso2.registry.ResourceImpl;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;

public class AddResourceAction extends AbstractRegistryAction {

    private String resourceName;
    private String parentPath;
    private String description;
    private File uploadedFile;

    public String execute() throws Exception {

        Registry registry = getRegistry();

        String path ;

        if (parentPath.equals(RegistryConstants.ROOT_PATH)) {
            path = RegistryConstants.ROOT_PATH + resourceName;
        } else {
            path = parentPath + RegistryConstants.PATH_SEPARATOR + resourceName;
        }

        ByteArrayOutputStream out = new ByteArrayOutputStream();
        FileInputStream fileStream = new FileInputStream(uploadedFile);

        //int data;
        //while ((data = fileStream.read()) != -1) {
        //    out.write(data);
        //}
        //
        //byte[] fileContent = out.toByteArray();
        //
        //fileStream.close();
        //out.close();

        ResourceImpl resource = new ResourceImpl();
        resource.setPath(path);
        resource.setDescription(description);
        resource.setContentStream(fileStream);

        registry.put(path, resource);

        return SUCCESS;
    }

    public String getResourceName() {
        return resourceName;
    }

    public void setResourceName(String resourceName) {
        this.resourceName = resourceName;
    }

    public String getParentPath() {
        return parentPath;
    }

    public void setParentPath(String parentPath) {

        if (parentPath.indexOf("?") > 0) {
            parentPath = parentPath.split("\\?")[0];
        }
        
        this.parentPath = parentPath;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public File getUploadedFile() {
        return uploadedFile;
    }

    public void setUploadedFile(File uploadedFile) {
        this.uploadedFile = uploadedFile;
    }
}
